camera = {
  x = 0, y = 0, -- Position
  r = 0,        -- Rotation
  z = 1         -- Zoom (Scale)
}

function camera.set()
  love.graphics.push()
  love.graphics.rotate(camera.r)
  love.graphics.scale(1/camera.z, 1/camera.z)
  love.graphics.translate(-camera.x,-camera.y)
end

function camera.setPosition(nx, ny)
  camera.x = nx or 0
  camera.y = ny or 0
end
function camera.move(dx, dy)
  camera.x = camera.x + (dx or 0)
  camera.y = camera.y + (dy or 0)
end

function camera.rotate(dr)
  camera.r = camera.r + (dr or 0)
end

--NOT YET RECOMMENDED (It doesn't center around a chosen point)
-- (+)Zoom In (-) Zoom Out
function camera.zoom(z)
  camera.z = camera.z - (z or 0)
end

-- Camera Limits
function camera.clampX(min, max)
  camera.x = math.max(camera.x, min) -- Returns the larger value
  camera.x = math.min(camera.x, max) -- Returns the smaller value
end
function camera.clampY(min, max)
  camera.y = math.max(camera.y, min)
  camera.y = math.min(camera.y, max)
end

function camera.unset()
  love.graphics.pop()
end
