-- Angle in Radians
function getAngle(x1, y1, x2, y2)
  return math.atan2(y2 - y1, x2 - x1)
end

function getCircleCircleDistance(x1, y1, r1, x2, y2, r2)
  local radius1 = r1 or 0
  local radius2 = r2 or 0
  
  return math.sqrt(((x2 - x1) ^ 2) + ((y2 - y1) ^ 2)) - (radius1 + radius2)
end

function getCircleRectangleDistance(cx, cy, cr, rx, ry, rw, rh)
  local tx, ty = cx, cy
  local tr = cr or 0
  
  -- Adjusting tx to which Rectangle EdgeX it's closest to.
  if cx < rx then
    tx = rx
  elseif cx > rx + rw then
    tx = rx + rw
  end
  
  -- Adjusting tx to which Rectangle EdgeY it's closest to.
  if cy < ry then
    ty = ry
  elseif cy > ry + rh then
    ty = ry + rh
  end
  
  -- distance
  return math.sqrt(((cx - tx) ^ 2) + ((cy - ty) ^ 2)) - tr
end

function getOrbitX(x, angle, distance)
  return x + (distance * math.cos(angle))
end

function getOrbitY(y, angle, distance)
  return y + (distance * math.sin(angle))
end

function getOrbitPosition(x, y, angle, distance)
  local nx = x + (distance * math.cos(angle))
  local ny = y + (distance * math.sin(angle))

  return nx, ny
end

function getVelocityX(speed, angle)
  return speed * math.cos(angle)
end

function getVelocityY(speed, angle)
  return speed * math.sin(angle)
end

function getVelocity(speed, angle)
  local vx = speed * math.cos(angle)
  local vy = speed * math.sin(angle)
   
  return vx, vy
end
