local tile_width, tile_height = 32, 30

function newPlayer(x, y, v)
  local img = love.graphics.newImage('img/player' .. v .. '.png')
  local pk = newAnimatedEntityKit(img)

  pk.newAnimation('idle',    {0,   0, tile_width, tile_height, 4}, 0.15)
  pk.newAnimation('ready',   {0,  31, tile_width, tile_height, 4}, 0.75)
  pk.newAnimation('walking', {0,  62, tile_width, tile_height, 2}, 0.15)
  pk.newAnimation('victory', {0,  93, tile_width, tile_height, 2}, 0.35)
  pk.newAnimation('defeat',  {0, 124, tile_width, tile_height, 2}, 0.70)

  local player = pk.spawn(x, y, tile_width, tile_height)
  player:setAnimation('idle', false)
  player.blinktime = love.math.random(8)
  
  function player:update(dt)
    if not self.playing then
    -- It will stop playing because I kept setting 'idle' to not loop
      self.blinktime = self.blinktime - dt
      if self.blinktime <= 0 then
        self.blinktime = love.math.random(8)
        self:replayAnimation()
      end
    end
    self:updateAnimation(dt)
  end
  
  return player
end