state_pause = newState()

local function unpause()
  board.updating = true
  menu.active = false
  state_machine.pop()
end

function state_pause.load()
  board.updating = false
  
  menu.buttons = {}
  menu:addButton('RESUME', screen.width / 2, screen.height / 2 - 22, function() unpause() end)
  menu:addButton('SAVE',   screen.width / 2, screen.height / 2     , function() state_machine.push(state_save) end)
  menu:addButton('QUIT',   screen.width / 2, screen.height / 2 + 22, function() state_machine.change(state_title) end)
  menu.selected_index = 1
  menu.active = true
end

function state_pause.draw()
  love.graphics.setColor(0,0,0,0.3)
  love.graphics.rectangle('fill', 0, 0, screen.width, screen.height)
  menu:draw()
end
 
function state_pause.keypressed(key)
  if key == 'return' then
    menu:press()
  elseif key == 'up' or key == 'left' then
    menu:cycleUp()
  elseif key == 'down' or key == 'right' then
    menu:cycleDown()
  elseif key == 'escape' then
    unpause()
  end
end

function state_pause.keyreleased(key)
  menu:release()
end