state_selectplayers = newState()

local board_index, players, textwidth, selected_player

function state_selectplayers.load(index)
  board_index = index
  
  textwidth = screen.width / (#board.players + 1)
  
  players = {}
  for i = 1, #board.players do
    table.insert(players, newPlayer(i * textwidth, screen.height / 2 - 44, i))
    board.players[i].ai = i > 1
  end

  selected_player = 1

  menu.buttons = {}
  menu:addButton('SWITCH', screen.width / 2, screen.height / 2 + 22, function() board.players[selected_player].ai = not board.players[selected_player].ai end)
  menu:addButton('PLAY',   screen.width / 2, screen.height / 2 + 44, function() state_machine.change(state_play) end)
  menu:addButton('BACK',   screen.width / 2, screen.height / 2 + 66, function() state_machine.change(state_selectboard, board_index) end)
  menu.selected_index = 1

end

function state_selectplayers.update(dt)
  for _, v in pairs(players) do v:update(dt) end
end

function state_selectplayers.draw()
  love.graphics.setColor(0,0,0,0.3)
  love.graphics.rectangle('fill', 0, 0, screen.width, screen.height)
  for i, v in pairs(players) do
    love.graphics.setColor(1,1,1)
    v:draw()
    love.graphics.setColor(i == selected_player and {1,1,0} or {1,1,1})
    love.graphics.rectangle('line', v.x - v.ox, v.y - v.oy, v.width, v.height, 2, 2)
    love.graphics.printf(board.players[i].ai and 'AI' or 'Human', v.x - textwidth/2, v.y + 15, textwidth, 'center')
  end
  menu:draw()
end

function state_selectplayers.keypressed(key)
  if key == 'up' then
    menu:cycleUp()
  elseif key == 'down' then
    menu:cycleDown()
  elseif key == 'left' then
    selected_player = selected_player == 1 and #board.players or selected_player - 1
  elseif key == 'right' then
    selected_player = selected_player == #board.players and 1 or selected_player + 1
  elseif key == 'escape' then
    state_machine.change(state_selectboard, board_index)
  elseif key == 'return' or key == 'kpenter' or key == 'space' then
    menu:press()
  end
end
function state_selectplayers.keyreleased(key)
  menu:release()
end